<template>
  <div>
    <div>

      <h1>Dodaj matkę:</h1>

      <form
          v-on:submit.prevent="submitForm"
      >

        <div class="form-group">

          <div v-if="wasSubmitted && !form.dateOfApplication">
            <p style="color: red;">Uzupełnij: </p>
          </div>

          <label for="dateOfApplication">Data wstawienia do ula:</label>
          <vue-englishdatepicker id="dateOfApplication" v-model="form.dateOfApplication"/>
        </div>

        <div class="form-group">
          <label for="queenNo">Nr królowej:</label>
          <input type="text" class="form-control" id="queenNo" @keypress="onlyNumber" placeholder="Numer królowej"
                 v-model="form.queenNo" required>
        </div>

        <div class="form-group">
          <label for="colour">Kolor królowej:</label>
          <input type="text" class="form-control" id="colour" placeholder="Kolor królowej"
                 v-model="form.colour" required maxlength="20">
        </div>

        <div class="form-group">
          <label for="variety">Rasa królowej:</label>
          <input type="text" class="form-control" id="variety" placeholder="Rasa królowej"
                 v-model="form.variety" required maxlength="20">
        </div>

        <div class="form-group">
          <label for="fertile">Płodna?</label>
          <input type="checkbox" unchecked-value="false" id="fertile" v-model="form.fertile"
                 value="false">
        </div>

        <div class="form-group">
          <button class="btn btn-primary">Dodaj</button>
        </div>
      </form>
    </div>

  </div>
</template>

<script>
import QueenService from '../../services/queen.service';
import VueEnglishdatepicker from 'vue-englishdatepicker';

import 'vue-slider-component/theme/antd.css'
import queenobject from "@/models/queenobject";

export default {
  name: 'AddInspection',
  components: {
    VueEnglishdatepicker,
  },
  data() {
    return {
      content: '',
      form: new queenobject('', '', false, '', '', ''),
      wasSubmitted: false,
    };
  },
  computed: {
    currentUser() {
      return this.$store.state.auth.user;
    }
  },
  mounted() {

  },
  methods: {
    submitForm() {

      if (!this.currentUser) {
        this.$router.push('/login');
      } else {

        this.wasSubmitted = true


        if (!this.currentUser) {
          this.$router.push('/login');
        } else if (this.$route.query.beehiveId) {

          if (this.checkObject()) {

            this.form.beehiveId = this.$route.query.beehiveId;

            QueenService.addNewQueen(this.form).then(
                response => {
                  this.content = response.data;

                  alert('Królowa dodana poprawnie!')

                  this.$router.push('/beehive?beehiveid=' + this.$route.query.beehiveId)

                },
                error => {
                  this.content =
                      (error.response && error.response.data && error.response.data.message) ||
                      error.message ||
                      error.toString();
                }
            );
          } else
            alert('Uzupełnij brakujące dane!')
        }
      }
    },

    checkObject() {
      if (!this.form.dateOfApplication)
        return false
      else
        return true
    },

    onlyNumber($event) {
      let keyCode = ($event.keyCode ? $event.keyCode : $event.which);
      if ((keyCode < 48 || keyCode > 57) && keyCode !== 46) { // 46 is dot
        $event.preventDefault();
      }
    }

  }
};
</script>

<style scoped>
label {
  display: block;
  margin-top: 10px;
}

</style>